#include <cuda_runtime.h>

namespace recognition {

Matrix2f NormalizeImage(Matrix2uchar m_image, int *stoch_vect, const unsigned v_length, float skip, img_t &sum, unsigned &n_elements);

void NormalizeImage(SparseImage &img, img_t &sum);

template< typename T >
SparseImage GetSparseImage(Matrix<T> img, float p);

template< typename R, typename T >
R* GetIntegralRepresentation(T* image, int height, int width, int power);

template< typename R, typename T >
R* GetIntegralRepr(T* image, int height, int width);

template< typename R, typename T >
R* GetIntegralReprSquared(T* image, int height, int width);

// sumOfRect(ABCD) = II(A) + II(C) - II(B) - II(D)
template< typename T >
__host__ __device__ T EvalIntegralReprSum(T* image, int stride, int top, int left, int height, int width);

}	// namespace recognition
