#ifndef TM_DEBUG_SIMPLE_TEST_H_
#define TM_DEBUG_SIMPLE_TEST_H_

#include <cv.h>

#define RECOLOR_DEFAULT_VAL 1

namespace recognition {

void DEBUG_Recolor(cv::Mat image, double color = RECOLOR_DEFAULT_VAL);
void DEBUG_DrawCircle(cv::Mat image, int x_offset, int y_offset, int radius,
		int angle_incr, double color = 1, bool bold = false);
void DEBUG_DrawLine(cv::Mat image, int x_offset, int y_offset, int x_start, int y_start, int x_end, int y_end,
		int line_incr, double color, bool bold);
void DEBUG_AffineMatrix(cv::Mat I1, cv::Mat I2);
void DEBUG_DrawBoldPoint(cv::Mat image, int y, int x, double color);

SecondGradePoint DEBUG_RunCiratefiCPU(recognition::gpu::Ciratefi ciratefi);
SecondGradePoint DEBUG_RunCiratefiGPU(recognition::gpu::Ciratefi ciratefi);
void DEBUG_RunCiratefi(recognition::gpu::Ciratefi ciratefi);

}	// namespace recognition

#endif	// TM_DEBUG_SIMPLE_TEST_H_
