#ifndef TM_GPU_FAST_MATCH_HELPER_H_
#define TM_GPU_FAST_MATCH_HELPER_H_

//#include <cuda_runtime.h>
#include <cv.h>

#define MAX_TRANSFORMATIONS 70000000

namespace recognition {

struct NetParameters {
	double tx;
	double ty;
	double r;
	double s;
};

struct BestTransformationResult {
//	BestTransformationResult(): deviation(0), time(0) {}

	cv::Mat bestConfig;
	cv::Mat bestTransMat;
	double sampledError;
};

struct _cu_findDistancesKernelArgs {
	_cu_findDistancesKernelArgs(int numPoints_, int r2x_, int r2y_, int w2_, int h2_, int usePhotometrics_):
		numPoints(numPoints_), r2x(r2x_), r2y(r2y_), w2(w2_), h2(h2_), usePhotometrics(usePhotometrics_) {}

	int numPoints;
	int r2x;
	int r2y;
	int w2;
	int h2;
	int usePhotometrics;
};

template < typename T >
void generateRangeWithStep(cv::Mat &I, T from, T step);

template < typename T >
T mean(cv::Mat &vec, int from, int to);

} // namespace recognition

#endif	// TM_GPU_FAST_MATCH_HELPER_H_
