#include <base/types.cuh>

namespace recognition {

// Finds maximum
__device__ volatile CorrelationPoint& CorrelationPoint::operator += (volatile const CorrelationPoint &rhs) volatile {
	if (rhs.corr >= this->corr) {
		this->corr = rhs.corr;
		this->x = rhs.x;
		this->y = rhs.y;
	}

	return *this;
}

__host__ __device__ CorrelationPoint& CorrelationPoint::operator = (CorrelationPoint &rhs) {
	if (this == &rhs)
		return *this;

	this->corr = rhs.corr;
	this->x = rhs.x;
	this->y = rhs.y;

	return rhs;
}

}	// namespace recognition
