#include <gpu/fast_match_helper.cuh>

namespace recognition {

template < typename T >
void generateRangeWithStep(cv::Mat &I, T from, T step) {
	CV_Assert(I.depth() != sizeof(T));

	cv::MatIterator_<T> it, end;
	T val = from;
	for (it = I.begin<T>(), end = I.end<T>(); it != end; ++it) {
		*it = val;
		val += step;
	}
}

template void generateRangeWithStep(cv::Mat &I, double from, double step);

template < typename T >
// to exclusive
T mean(cv::Mat &vec, int from, int to) {
	T mean_ = 0;
	T* ptr = vec.ptr<T>(0);
	for (int i = from; i < to; ++i) {
		mean_ += ptr[i];
	}

	return mean_ / (to - from);
}

template double mean(cv::Mat &vec, int from, int to);

}	// namespace recognition
