#include <cuda_runtime.h>

namespace recognition {
namespace gpu {

// Get a matrix element
__device__ img_t _cu_getElement(const Matrix2f A, int row, int col);

// Set a matrix element
__device__ void _cu_setElement(Matrix2f A, int row, int col, img_t value);

// Get the (width x height) sub-matrix Asub of A that is
// located col sub-matrices to the right and row sub-matrices down
// from the upper-left corner of A (all sub-matrices are aligned
// by BLOCK_SIZE both dimensions)
__device__ Matrix2f _cu_getSubMatrix(Matrix2f *A, int row, int col);

__host__ void _cu_catch(cudaError_t error, const char *message);

template <unsigned int blockSize>
__device__ void _cu_warpReduce(volatile CorrelationPoint *sdata, unsigned int tid);

template <unsigned int blockSize>
__global__ void _cu_reduceMaxKernel(CorrelationPoint *g_idata, CorrelationPoint *g_odata, unsigned int n);

}	// namespace gpu
}	// namespace recognition
