const char *RESOURCES_DIRECTORY = "images";
const char *CONFIG_DIRECTORY = "config";
const char *CONFIG_FILE_XML = "log4cxx-config.xml";

const char FILE_PATH_SEPARATOR =
#ifdef _WIN32
		'\\';
#else
		'/';
#endif

#pragma pack(push, 1)
typedef struct tagBITMAPFILEHEADER {
    short bfType;  //specifies the file type
    unsigned int bfSize;  //specifies the size in bytes of the bitmap file
    short bfReserved1;  //reserved; must be 0
    short bfReserved2;  //reserved; must be 0
    unsigned int bOffBits;  //species the offset in bytes from the bitmapfileheader to the bitmap bits
} BITMAPFILEHEADER;
#pragma pack(pop)

namespace recognition {

unsigned char* ReadBitmapImageFile(char *name);

unsigned char* RawBmpToRgb(unsigned char* image, int height, int width);

unsigned char* ReadBmpRgb(char *name, int height, int width);

unsigned char *BmpRgbToGrayscale(unsigned char *image, int height, int width);

}	// namespace recognition
